unit Unit1;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, DB, DBTables, Spin, Grids, DBGrids, Dbgrscr;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Table1: TTable;
    DataSource1: TDataSource;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    Label3: TLabel;
    Button2: TButton;
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
implementation

{$R *.DFM}

var DBGridScr: TDBGridScr;

procedure TForm1.FormCreate(Sender: TObject);
begin
{	WindowState:=wsNormal;
  Height:=320;}
{$ifndef windows}
	Table1.Filtered:=True;
{$endif}
	Table1.Open;

{creating of component at run-time}
  DBGridScr:=TDBGridScr.Create(self);
  with DBGridScr do begin
  	Parent:=Panel1;
    DataSource:=DataSource1;
    Align:=alClient;
    Left:=6;Top:=6;
  end;

  {this is a MUST !!!}
	DBGridScr.RecCount:=DBGridScr.CountRecs;
  {!!!!!!!!!}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	Table1.FindKey([SpinEdit1.Text]);
{
		property UpdateToEnd

After sucessfull FindKey is updated position of thumb. With greater number of
records it has sense to set property UpdateToEnd.

if Table1.FindKey([SpinEdit1.Text]) then
	DBGridScr.UpdateToEnd:=StrToInt(SpinEdit1.Text)>(DBGridScr.RecCount-FirstValue)/2;
}
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
	if (Field= nil) and (DBGridScr<>nil) then
		Label3.Caption:=Format('%d of %d',[DBGridScr.Position,DBGridScr.RecCount]);
end;

procedure TForm1.Button2Click(Sender: TObject);
var i: Integer;
begin
{if you want to have successive OrderNo in Orders.db}
	Table1.First;
  while not Table1.Eof do begin
  	i:=Table1.FieldByName('OrderNo').AsInteger;
  	if i>1900 then Break;
 		Table1.Next;
		if (i+1)<>Table1.FieldByName('OrderNo').AsInteger then
    begin
			Table1.Insert;
			Table1.FieldByName('OrderNo').AsInteger:=i+1;
			Table1.FieldByName('CustNo').AsInteger:=1221;
			Table1.FieldByName('EmpNo').AsInteger:=9;
      Table1.Post;
			Application.ProcessMessages;
	  end;
  end;
end;

end.
